## mingw-w64-serial-studio-3.0.6-1.src.tar.zst

=== CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.20)

#-------------------------------------------------------------------------------
# Define project name & find Qt packages for correct CPack calls
#-------------------------------------------------------------------------------

project(Serial-Studio LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(
 Qt6 REQUIRED
 COMPONENTS
 Core
 Qml
)

#-------------------------------------------------------------------------------
# Options for build types
#-------------------------------------------------------------------------------

option(DEBUG_SANITIZER "Enable sanitizers for debug builds" OFF)
option(PRODUCTION_OPTIMIZATION "Enable production optimization flags" OFF)

#-------------------------------------------------------------------------------
# Project information
#-------------------------------------------------------------------------------

set(PROJECT_DISPNAME            "Serial Studio")
set(PROJECT_EXECUTABLE          "Serial-Studio")
set(PROJECT_VENDOR              "Alex Spataru")
set(PROJECT_CONTACT             "serial-studio.github.io")
set(PROJECT_DESCRIPTION_SUMMARY "Flexible data visualization software for embedded devices and projects")
set(PROJECT_VERSION_MAJOR       "3")
set(PROJECT_VERSION_MINOR       "0")
set(PROJECT_VERSION_PATCH       "6")
set(PROJECT_VERSION             "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
set(PROJECT_APPCAST             "https://raw.githubusercontent.com/Serial-Studio/Serial-Studio/master/updates.json")

set(PROJECT_ROOT_DIR            ${CMAKE_CURRENT_LIST_DIR})
set(PROJECT_DESCRIPTION_FILE    "${PROJECT_ROOT_DIR}/README.md")
set(PROJECT_FILE_NAME           "${PROJECT_EXECUTABLE}-v${PROJECT_VERSION}")
set(PROJECT_FILE_LICENSE        "${PROJECT_ROOT_DIR}/LICENSE.md")

#-------------------------------------------------------------------------------
# Allow source code to access project information
#-------------------------------------------------------------------------------

add_definitions(-DPROJECT_VENDOR="${PROJECT_VENDOR}")
add_definitions(-DPROJECT_CONTACT="${PROJECT_CONTACT}")
add_definitions(-DPROJECT_VERSION="${PROJECT_VERSION}")
add_definitions(-DPROJECT_APPCAST="${PROJECT_APPCAST}")
add_definitions(-DPROJECT_DISPNAME="${PROJECT_DISPNAME}")

#-------------------------------------------------------------------------------
# Set UNIX friendly name for app & fix OpenSUSE builds
#-------------------------------------------------------------------------------

if (UNIX AND NOT APPLE)
 set(PROJECT_EXECUTABLE "serial-studio")
 set(CMAKE_C_COMPILER_AR "/usr/bin/ar")
 set(CMAKE_CXX_COMPILER_AR "/usr/bin/ar")
 set(CMAKE_C_COMPILER_RANLIB "/usr/bin/ranlib")
 set(CMAKE_CXX_COMPILER_RANLIB "/usr/bin/ranlib")
endif()

#-------------------------------------------------------------------------------
# CPU architecture configuration
#-------------------------------------------------------------------------------

if(APPLE) 
  if(CMAKE_OSX_ARCHITECTURES MATCHES "x86_64")
    set(CMAKE_SYSTEM_PROCESSOR "x86_64")
  elseif(CMAKE_OSX_ARCHITECTURES MATCHES "arm64")
    set(CMAKE_SYSTEM_PROCESSOR "arm64")
  endif()
endif()

#-------------------------------------------------------------------------------
# Production optimization flags
#-------------------------------------------------------------------------------

if(PRODUCTION_OPTIMIZATION)
 # MinGW-specific settings
 if(WIN32 AND MINGW)
  add_compile_options(
   -O3                            # Optimize for speed
   -Wall                          # Enable most warning messages
   -Wextra                        # Enable additional warning messages
   -fuse-linker-plugin            # Use LTO plugin
   -ftree-vectorize               # Enable loop vectorization
   -fno-fast-math                 # Standard-compliant floating point math
   -fno-unsafe-math-optimizations # Use safe math only
  )
  add_link_options(
   -Wl,--gc-sections              # Remove unused sections during linking
   -fuse-linker-plugin            # Enable LTO during linking
  )

 # MSVC-specific settings
 elseif(WIN32 AND MSVC)
  add_compile_options(
   /openmp:experimental           # Add support for OpenMP
   /permissive-                   # Enable strict ISO compliance
   /Zc:__cplusplus                # Correct __cplusplus value
   /Zc:preprocessor               # Enable standards-conforming preprocessor
   /MP                            # Multi-processor compilation
   /vmg                           # Use general pointer-to-member representation
   /Ox                            # Optimize for speed
   /W3                            # Warning level 3 messages
   /GL                            # Enable whole program optimization
   /MT                            # Link compiler runtime statically
   /Qvec                          # Enable loop vectorization
   /fp:strict                     # Standard-compliant floating point math
  )
  add_link_options(
   /OPT:REF                       # Remove unreferenced functions/data
   /OPT:ICF                       # Remove identical COMDATs
   /LTCG                          # Enable LTO during linkingn
  )

 # macOS-specific settings
 elseif(APPLE)
  include_directories(
   "/opt/homebrew/opt/libomp/include"
   "/opt/homebrew/opt/llvm/include"
  )
  link_directories(
   "/opt/homebrew/opt/libomp/lib"
   "/opt/homebrew/opt/llvm/lib"
  )

  add_compile_options(
   -O3                            # Optimize for speed
   -Wall                          # Enable most warning messages
   -Wextra                        # Enable additional warning messages
   -fopenmp=libomp                # Add support for OpenMP
   -fvectorize                    # Enable loop vectorization
   -fslp-vectorize                # Enable SLP vectorization
   -fno-fast-math                 # Standard-compliant floating point math
   -fno-unsafe-math-optimizations # Use safe math only
  )
  add_link_options(
   -Wl,-dead_strip                # Remove unused code and data during linking
   -flto=full                     # Link-time optimization
  )

 # Intel LLVM-based C++ Compiler
 elseif(CMAKE_CXX_COMPILER_ID MATCHES "IntelLLVM")
  add_compile_options(
   -O3                            # Optimize for speed
   -Wall                          # Enable most warning messages
   -Wextra                        # Enable additional warning messages
   -qopenmp-simd                  # Add support for OpenMP
   -static-intel                  # Static link compiler dependencies
   -fvectorize                    # Enable loop vectorization
   -fslp-vectorize                # Enable SLP vectorization
   -fp-model=precise              # Standard-compliant floating point math
  )
  add_link_options(
   -Wl,--gc-sections              # Remove unused sections during linking
   -flto=full                     # Link-time optimization
  )

 # Generic UNIX/Linux settings
 elseif(UNIX)
  add_compile_options(
   -O3                            # Optimize for speed
   -Wall                          # Enable most warning messages
   -Wextra                        # Enable additional warning messages
   -fopenmp                       # Add support for OpenMP
   -ftree-vectorize               # Enable loop vectorization
   -fno-fast-math                 # Standard-compliant floating point math
   -fno-unsafe-math-optimizations # Use safe math only
  )
  add_link_options(
   -Wl,--gc-sections              # Remove unused sections during linking
   -flto                          # Link-time optimization
  )
 endif()
endif()

#-------------------------------------------------------------------------------
# Sanitizer flags
#-------------------------------------------------------------------------------

if(DEBUG_SANITIZER)
 add_compile_options(
  -fsanitize=address              # Enable AddressSanitizer
  -fsanitize=undefined            # Enable UndefinedBehaviorSanitizer
  -fsanitize=leak                 # Enable LeakSanitizer
  -g                              # Generate debug symbols
  -fno-omit-frame-pointer         # Preserve frame pointers
 )

 add_link_options(
  -fsanitize=address              # Link AddressSanitizer
  -fsanitize=undefined            # Link UndefinedBehaviorSanitizer
  -fsanitize=leak                 # Link LeakSanitizer
 )
endif()

#-------------------------------------------------------------------------------
# Add subdirectories
#-------------------------------------------------------------------------------

add_subdirectory(lib)
add_subdirectory(app)

#-------------------------------------------------------------------------------
# Log compiler and linker flags
#-------------------------------------------------------------------------------

get_directory_property(SUBDIRECTORY_COMPILE_OPTIONS DIRECTORY lib COMPILE_OPTIONS)
message(STATUS "LIB Compile Options: ${SUBDIRECTORY_COMPILE_OPTIONS}")

get_directory_property(SUBDIRECTORY_COMPILE_OPTIONS DIRECTORY app COMPILE_OPTIONS)
message(STATUS "APP Compile Options: ${SUBDIRECTORY_COMPILE_OPTIONS}")

=== app/CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

#-------------------------------------------------------------------------------
# Project setup
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.20)
project(app LANGUAGES CXX)

#-------------------------------------------------------------------------------
# C++ options
#-------------------------------------------------------------------------------

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#-------------------------------------------------------------------------------
# Add external dependencies (Qt)
#-------------------------------------------------------------------------------

find_package(
 Qt6 REQUIRED
 COMPONENTS
 Svg
 Gui
 Qml
 Core
 Quick
 Graphs
 Widgets
 Location
 Bluetooth
 SerialPort
 Positioning
 PrintSupport
 LinguistTools
 QuickControls2
)

qt_standard_project_setup()

qt_policy(SET QTP0001 NEW)
qt_policy(SET QTP0004 NEW)

#-------------------------------------------------------------------------------
# Import source code
#-------------------------------------------------------------------------------

include_directories(src)

set(SOURCES
 src/Misc/ThemeManager.cpp
 src/Misc/CommonFonts.cpp
 src/Misc/Utilities.cpp
 src/Misc/Translator.cpp
 src/Misc/ModuleManager.cpp
 src/Misc/TimerEvents.cpp
 src/UI/DashboardWidget.cpp
 src/UI/Dashboard.cpp
 src/UI/Widgets/LEDPanel.cpp
 src/UI/Widgets/Gauge.cpp
 src/UI/Widgets/Plot.cpp
 src/UI/Widgets/Compass.cpp
 src/UI/Widgets/Bar.cpp
 src/UI/Widgets/FFTPlot.cpp
 src/UI/Widgets/Accelerometer.cpp
 src/UI/Widgets/DataGrid.cpp
 src/UI/Widgets/Terminal.cpp
 src/UI/Widgets/Gyroscope.cpp
 src/UI/Widgets/GPS.cpp
 src/UI/Widgets/MultiPlot.cpp
 src/Plugins/Server.cpp
 src/IO/Drivers/Network.cpp
 src/IO/Drivers/Serial.cpp
 src/IO/Drivers/BluetoothLE.cpp
 src/IO/Checksum.cpp
 src/IO/Console.cpp
 src/IO/Manager.cpp
 src/IO/FileTransmission.cpp
 src/IO/FrameReader.cpp
 src/JSON/FrameParser.cpp
 src/JSON/ProjectModel.cpp
 src/JSON/FrameBuilder.cpp
 src/JSON/Frame.cpp
 src/JSON/Action.cpp
 src/JSON/Dataset.cpp
 src/JSON/Group.cpp
 src/CSV/Player.cpp
 src/CSV/Export.cpp
 src/MQTT/Client.cpp
 src/main.cpp
 src/SerialStudio.cpp
)

set(HEADERS
 src/Misc/ModuleManager.h
 src/Misc/Utilities.h
 src/Misc/CommonFonts.h
 src/Misc/ThemeManager.h
 src/Misc/TimerEvents.h
 src/Misc/Translator.h
 src/UI/Dashboard.h
 src/UI/DashboardWidget.h
 src/UI/Widgets/GPS.h
 src/UI/Widgets/MultiPlot.h
 src/UI/Widgets/Gauge.h
 src/UI/Widgets/Plot.h
 src/UI/Widgets/DataGrid.h
 src/UI/Widgets/FFTPlot.h
 src/UI/Widgets/Gyroscope.h
 src/UI/Widgets/Bar.h
 src/UI/Widgets/Accelerometer.h
 src/UI/Widgets/LEDPanel.h
 src/UI/Widgets/Compass.h
 src/UI/Widgets/Terminal.h
 src/Plugins/Server.h
 src/Platform/NativeWindow.h
 src/Misc/OsmTemplateServer.h
 src/IO/Console.h
 src/IO/Drivers/Serial.h
 src/IO/Drivers/Network.h
 src/IO/Drivers/BluetoothLE.h
 src/IO/Manager.h
 src/IO/HAL_Driver.h
 src/IO/Checksum.h
 src/IO/CircularBuffer.h
 src/IO/FileTransmission.h
 src/IO/FrameReader.h
 src/JSON/FrameParser.h
 src/JSON/ProjectModel.h
 src/JSON/Frame.h
 src/JSON/Action.h
 src/JSON/Dataset.h
 src/JSON/Group.h
 src/JSON/FrameBuilder.h
 src/CSV/Export.h
 src/CSV/Player.h
 src/MQTT/Client.h
 src/SIMD/SIMD.h
 src/AppInfo.h
 src/SerialStudio.h
)

#-------------------------------------------------------------------------------
# Platform-specific configuration
#-------------------------------------------------------------------------------

if(WIN32)
 set(WIN_RC "${CMAKE_CURRENT_SOURCE_DIR}/deploy/windows/info.rc")
 set(SOURCES ${SOURCES} ${WIN_RC} "src/Platform/NativeWindow_Windows.cpp")
elseif(APPLE)
 set(ICON_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/deploy/macOS/icon.icns")
 set(INFO_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/deploy/macOS/info.plist")
 set_source_files_properties(
  ${ICON_MACOSX}
  PROPERTIES MACOSX_PACKAGE_LOCATION "Resources"
 )
 set(SOURCES ${SOURCES} ${ICON_MACOSX} "src/Platform/NativeWindow_macOS.mm")
 set_source_files_properties(
  "src/Platform/NativeWindow_macOS.mm" PROPERTIES SKIP_UNITY_BUILD_INCLUSION ON
 )
elseif(UNIX)
 set(SOURCES ${SOURCES} "src/Platform/NativeWindow_UNIX.cpp")
endif()

#-------------------------------------------------------------------------------
# Add resources
#-------------------------------------------------------------------------------

qt_add_resources(QML_RCC ${CMAKE_CURRENT_SOURCE_DIR}/qml/qml.qrc)
qt_add_resources(RES_RCC ${CMAKE_CURRENT_SOURCE_DIR}/rcc/rcc.qrc)
qt_add_resources(QM_RCC ${CMAKE_CURRENT_SOURCE_DIR}/translations/translations.qrc)

#-------------------------------------------------------------------------------
# Create executable
#-------------------------------------------------------------------------------

qt_add_executable(
 ${PROJECT_EXECUTABLE}
 ${SOURCES}
 ${HEADERS}
 ${QML_RCC}
 ${RES_RCC}
 ${QM_RCC}
 ${QT_RCC_TRANSLATIONS}
 ${APP_RCC_TRANSLATIONS}
 MANUAL_FINALIZATION
)

target_link_libraries(
 ${PROJECT_EXECUTABLE} PUBLIC

 Qt6::Core
 Qt6::Svg
 Qt6::Gui
 Qt6::Qml
 Qt6::Quick
 Qt6::Graphs
 Qt6::Widgets
 Qt6::Location
 Qt6::Bluetooth
 Qt6::SerialPort
 Qt6::Positioning
 Qt6::PrintSupport
 Qt6::QuickControls2

 simde
 qmqtt
 QCodeEditor
 QRealFourier
 QSimpleUpdater
)

target_link_openssl(
 ${PROJECT_EXECUTABLE}
 ${CMAKE_CURRENT_SOURCE_DIR}/../lib/OpenSSL
)

#-------------------------------------------------------------------------------
# Deployment options
#-------------------------------------------------------------------------------

if(WIN32)
 target_link_libraries(${PROJECT_EXECUTABLE} PRIVATE Dwmapi.lib)
 set_target_properties(
  ${PROJECT_EXECUTABLE} PROPERTIES
  WIN32_EXECUTABLE TRUE
 )
elseif(APPLE)
 set_target_properties(
  ${PROJECT_EXECUTABLE} PROPERTIES
  MACOSX_BUNDLE TRUE
  MACOSX_BUNDLE_ICON_FILE ${ICON_MACOSX}
  MACOSX_BUNDLE_INFO_PLIST ${INFO_MACOSX}
 )
elseif(UNIX)
 install(TARGETS ${PROJECT_EXECUTABLE} RUNTIME DESTINATION /usr/bin)

 install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/deploy/linux/serial-studio.png
  DESTINATION /usr/share/pixmaps
 )

install(
 FILES ${CMAKE_CURRENT_SOURCE_DIR}/deploy/linux/serial-studio.desktop
 DESTINATION /usr/share/applications
)
endif()

#-------------------------------------------------------------------------------
# Qt Deployment
#-------------------------------------------------------------------------------

qt_finalize_executable(${PROJECT_EXECUTABLE})

install(
 TARGETS ${PROJECT_EXECUTABLE}
 BUNDLE  DESTINATION .
 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

set(deploy_tool_options_arg "")
if(APPLE)
 set(deploy_tool_options_arg -hardened-runtime -appstore-compliant)
elseif(WIN32)
 set(deploy_tool_options_arg --no-compiler-runtime -force-openssl --release)
endif()

qt_generate_deploy_qml_app_script(
 TARGET ${PROJECT_EXECUTABLE}
 OUTPUT_SCRIPT deploy_script
 MACOS_BUNDLE_POST_BUILD
 NO_UNSUPPORTED_PLATFORM_ERROR
 DEPLOY_USER_QML_MODULES_ON_UNSUPPORTED_PLATFORM
 DEPLOY_TOOL_OPTIONS ${deploy_tool_options_arg}
)

install(SCRIPT ${deploy_script})

#-------------------------------------------------------------------------------
# Packaging
#-------------------------------------------------------------------------------

set(CPACK_PACKAGE_NAME                  ${PROJECT_DISPNAME})
set(CPACK_PACKAGE_CONTACT               ${PROJECT_CONTACT})
set(CPACK_PACKAGE_VENDOR                ${PROJECT_VENDOR})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY   ${PROJECT_DESCRIPTION_SUMMARY})
set(CPACK_PACKAGE_VERSION_MAJOR         ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR         ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH         ${PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_DESCRIPTION_FILE      ${PROJECT_DESCRIPTION_FILE})
set(CPACK_PACKAGE_FILE_NAME             ${PROJECT_FILE_NAME})
set(CPACK_RESOURCE_FILE_LICENSE         ${PROJECT_FILE_LICENSE})

set(CPACK_MONOLITHIC_INSTALL OFF)

if(WIN32)
 set(CPACK_PACKAGE_ICON              "${CMAKE_CURRENT_SOURCE_DIR}\\\\deploy\\\\windows\\\\icon.ico")
 set(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_NAME}")
else()
 set(CPACK_PACKAGE_ICON              "${CMAKE_CURRENT_SOURCE_DIR}/deploy/icon.png")
 set(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_NAME}")
endif()

if(NOT CPACK_GENERATOR)
 if(WIN32)
  set(CPACK_GENERATOR                             "NSIS")
  set(CPACK_NSIS_MANIFEST_DPI_AWARE               ON)
  set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL  ON)
  set(CPACK_NSIS_DISPLAY_NAME                     "${CPACK_PACKAGE_NAME}")
  set(CPACK_NSIS_MUI_FINISHPAGE_RUN               "${PROJECT_EXECUTABLE}")
  set(CPACK_NSIS_INSTALLED_ICON_NAME              "$INSTDIR\\\\bin\\\\${PROJECT_EXECUTABLE}.exe")
  set(CPACK_NSIS_MUI_ICON                         "${CMAKE_CURRENT_SOURCE_DIR}\\\\deploy\\\\windows\\\\icon.ico")
  set(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS         "Delete '$SMPROGRAMS\\\\${PROJECT_DISPNAME}.lnk'")
  set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS           "CreateShortCut '$SMPROGRAMS\\\\${PROJECT_DISPNAME}.lnk' '$INSTDIR\\\\bin\\\\${PROJECT_EXECUTABLE}.exe'")
 elseif(APPLE)
  set(CPACK_GENERATOR                             "DragNDrop")
 else()
  set(CPACK_GENERATOR                             "TGZ")
 endif()
endif()

include(CPack)

=== lib/CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.20)

add_subdirectory(simde)
add_subdirectory(qmqtt)
add_subdirectory(OpenSSL)
add_subdirectory(QCodeEditor)
add_subdirectory(QRealFourier)
add_subdirectory(QSimpleUpdater)

=== lib/OpenSSL/CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.20)

function(target_link_openssl TARGET BASE_DIR)
 if(WIN32)
  target_include_directories(${TARGET} PRIVATE ${BASE_DIR}/include)
  target_link_libraries(${TARGET} PRIVATE
   ws2_32
   gdi32
   advapi32
   crypt32
   user32
   ${BASE_DIR}/dll/Windows/libssl.lib
   ${BASE_DIR}/dll/Windows/libcrypto.lib
  )
elseif(APPLE)
 target_include_directories(${TARGET} PRIVATE ${BASE_DIR}/include)
 target_link_libraries(${TARGET} PRIVATE
  ${BASE_DIR}/dll/macOS/libssl.a
  ${BASE_DIR}/dll/macOS/libcrypto.a
 )
elseif(UNIX)
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(OPENSSL REQUIRED openssl)
 target_link_libraries(${TARGET} PRIVATE ${OPENSSL_LIBRARIES})
 target_include_directories(${TARGET} PRIVATE ${OPENSSL_INCLUDE_DIRS})
 target_compile_options(${TARGET} PRIVATE ${OPENSSL_CFLAGS_OTHER})
endif()
endfunction()

=== lib/QCodeEditor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(QCodeEditor)

set(CMAKE_CXX_STANDARD 17)

option(BUILD_EXAMPLE "Example building required" OFF)

if (${BUILD_EXAMPLE})
 message(STATUS "QCodeEditor example will be built.")
 add_subdirectory(example)
endif()

set(RESOURCES_FILE
 resources/qcodeeditor_resources.qrc
)

set(INCLUDE_FILES
 include/QHighlightRule
 include/QHighlightBlockRule
 include/QCodeEditor
 include/QCXXHighlighter
 include/QJavascriptHighlighter
 include/QLineNumberArea
 include/QStyleSyntaxHighlighter
 include/QSyntaxStyle
 include/QGLSLCompleter
 include/QGLSLHighlighter
 include/QLanguage
 include/QXMLHighlighter
 include/QJSONHighlighter
 include/QLuaCompleter
 include/QLuaHighlighter
 include/QPythonHighlighter
 include/QFramedTextAttribute
 include/QJavascriptCompleter
 include/internal/QHighlightRule.hpp
 include/internal/QHighlightBlockRule.hpp
 include/internal/QCodeEditor.hpp
 include/internal/QCXXHighlighter.hpp
 include/internal/QJavascriptHighlighter.hpp
 include/internal/QLineNumberArea.hpp
 include/internal/QStyleSyntaxHighlighter.hpp
 include/internal/QSyntaxStyle.hpp
 include/internal/QGLSLCompleter.hpp
 include/internal/QGLSLHighlighter.hpp
 include/internal/QLanguage.hpp
 include/internal/QXMLHighlighter.hpp
 include/internal/QJSONHighlighter.hpp
 include/internal/QLuaCompleter.hpp
 include/internal/QLuaHighlighter.hpp
 include/internal/QPythonCompleter.hpp
 include/internal/QPythonHighlighter.hpp
 include/internal/QFramedTextAttribute.hpp
 include/internal/QJavascriptCompleter.hpp
)

set(SOURCE_FILES
 src/internal/QCodeEditor.cpp
 src/internal/QLineNumberArea.cpp
 src/internal/QCXXHighlighter.cpp
 src/internal/QJavascriptHighlighter.cpp
 src/internal/QSyntaxStyle.cpp
 src/internal/QStyleSyntaxHighlighter.cpp
 src/internal/QGLSLCompleter.cpp
 src/internal/QGLSLHighlighter.cpp
 src/internal/QLanguage.cpp
 src/internal/QXMLHighlighter.cpp
 src/internal/QJSONHighlighter.cpp
 src/internal/QLuaCompleter.cpp
 src/internal/QLuaHighlighter.cpp
 src/internal/QPythonCompleter.cpp
 src/internal/QPythonHighlighter.cpp
 src/internal/QFramedTextAttribute.cpp
 src/internal/QJavascriptCompleter.cpp
)

# Create code for QObjects
set(CMAKE_AUTOMOC On)

# Create code from resource files
set(CMAKE_AUTORCC ON)

# Find includes in corresponding build directories
find_package(Qt6Core    CONFIG REQUIRED)
find_package(Qt6Widgets CONFIG REQUIRED)
find_package(Qt6Gui     CONFIG REQUIRED)

add_library(QCodeEditor STATIC
 ${RESOURCES_FILE}
 ${SOURCE_FILES}
 ${INCLUDE_FILES}
)

target_include_directories(QCodeEditor PUBLIC
 include
)

target_link_libraries(QCodeEditor
 Qt6::Core
 Qt6::Widgets
 Qt6::Gui
)

=== lib/QRealFourier/CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

#-------------------------------------------------------------------------------
# Project setup
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.20)
project(QRealFourier CXX)

#-------------------------------------------------------------------------------
# C++ options
#-------------------------------------------------------------------------------

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#-------------------------------------------------------------------------------
# Add external dependencies
#-------------------------------------------------------------------------------

find_package(Qt6 COMPONENTS Core REQUIRED)

#-------------------------------------------------------------------------------
# Import source code & resources
#-------------------------------------------------------------------------------

include_directories(headers)
include_directories(fftreal)

set(SOURCES
 sources/qcomplexnumber.cpp
 sources/qfouriercalculator.cpp
 sources/qfourierfixedcalculator.cpp
 sources/qfouriertransformer.cpp
 sources/qfouriervariablecalculator.cpp
 sources/qwindowfunction.cpp
)

set(HEADERS
 fftreal/Array.h
 fftreal/Array.hpp
 fftreal/DynArray.h
 fftreal/DynArray.hpp
 fftreal/FFTReal.h
 fftreal/FFTReal.hpp
 fftreal/FFTRealFixLen.h
 fftreal/FFTRealFixLen.hpp
 fftreal/FFTRealFixLenParam.h
 fftreal/FFTRealPassDirect.h
 fftreal/FFTRealPassDirect.hpp
 fftreal/FFTRealPassInverse.h
 fftreal/FFTRealPassInverse.hpp
 fftreal/FFTRealSelect.h
 fftreal/FFTRealSelect.hpp
 fftreal/FFTRealUseTrigo.h
 fftreal/FFTRealUseTrigo.hpp
 fftreal/OscSinCos.h
 fftreal/OscSinCos.hpp
 fftreal/def.h
 headers/qcomplexnumber.h
 headers/qfouriercalculator.h
 headers/qfourierfixedcalculator.h
 headers/qfouriertransformer.h
 headers/qfouriervariablecalculator.h
 headers/qwindowfunction.h
)

#-------------------------------------------------------------------------------
# Compile & link the library
#-------------------------------------------------------------------------------

add_library(
 QRealFourier
 STATIC
 ${SOURCES}
 ${HEADERS}
)

target_link_libraries(
 QRealFourier PUBLIC
 Qt6::Core
)

target_include_directories(
 QRealFourier PUBLIC
 ${CMAKE_CURRENT_SOURCE_DIR}/headers
)

=== lib/QSimpleUpdater/CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

#-------------------------------------------------------------------------------
# Project setup
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.20)
project(QSimpleUpdater CXX)

#-------------------------------------------------------------------------------
# C++ options
#-------------------------------------------------------------------------------

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#-------------------------------------------------------------------------------
# Add external dependencies
#-------------------------------------------------------------------------------

find_package(Qt6 COMPONENTS Core Gui Network Widgets REQUIRED)

#-------------------------------------------------------------------------------
# Fix linking errors
#-------------------------------------------------------------------------------

add_definitions(-DQSU_INCLUDE_MOC=1)

#-------------------------------------------------------------------------------
# Import source code & resources
#-------------------------------------------------------------------------------

include_directories(include)

set(SOURCES
 src/Updater.cpp
 src/Downloader.cpp
 src/QSimpleUpdater.cpp
 src/Downloader.ui
)

set(HEADERS
 src/Updater.h
 src/Downloader.h
 include/QSimpleUpdater.h
)

#-------------------------------------------------------------------------------
# Compile & link the library
#-------------------------------------------------------------------------------

qt_add_resources(QSU_RCC ${CMAKE_CURRENT_SOURCE_DIR}/etc/resources/qsimpleupdater.qrc)

add_library(
 QSimpleUpdater
 STATIC
 ${SOURCES}
 ${HEADERS}
 ${QSU_RCC}
)

target_link_libraries(
 QSimpleUpdater PUBLIC

 Qt6::Core
 Qt6::Gui
 Qt6::Network
 Qt6::Widgets
)

target_include_directories(
 QSimpleUpdater PUBLIC
 ${CMAKE_CURRENT_SOURCE_DIR}/src
 ${CMAKE_CURRENT_SOURCE_DIR}/include
)

=== lib/qmqtt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

project(qmqtt VERSION 1.0.3)

option(${PROJECT_NAME}_SHARED "Build a shared library.  Turn off for static." OFF)
option(${PROJECT_NAME}_WEBSOCKETS "Enable WebSockets for MQTT" OFF)
option(${PROJECT_NAME}_SSL "Enable SSL support for MQTT" ON)

if(${PROJECT_NAME}_SHARED)
 set(library_build_type SHARED)
 set(library_install_component Library)
else()
 set(library_build_type STATIC)
 set(library_install_component Devel)
endif()

set(ws_component)
set(ws_libname)
set(qt5_min_version "5.3.0")
set(qt6_min_version "6.2.4")

if(${PROJECT_NAME}_WEBSOCKETS)
 set(ws_component WebSockets)
 set(qt5_min_version "5.7.0")
endif()

if(NOT ${PROJECT_NAME}_SSL)
 set(ssl_defs QT_NO_SSL)
endif()

find_package(Qt6 ${qt6_min_version} COMPONENTS Core Network ${ws_component} CONFIG)
if(NOT Qt6_FOUND)
 find_package(Qt5 ${qt5_min_version} COMPONENTS Core Network ${ws_component} REQUIRED)
endif()

if(${PROJECT_NAME}_WEBSOCKETS)
 set(ws_libname "Qt${QT_VERSION_MAJOR}::WebSockets")
 find_package(Qt${QT_VERSION_MAJOR} COMPONENTS WebSockets REQUIRED)
endif()

set(CMAKE_AUTOMOC ON)

set(PUBLIC_HEADERS
 src/mqtt/qmqtt_global.h
 src/mqtt/qmqtt.h
 src/mqtt/qmqtt_client.h
 src/mqtt/qmqtt_frame.h
 src/mqtt/qmqtt_message.h
 src/mqtt/qmqtt_routesubscription.h
 src/mqtt/qmqtt_routedmessage.h
 src/mqtt/qmqtt_router.h
 src/mqtt/qmqtt_networkinterface.h
 src/mqtt/qmqtt_socketinterface.h
 src/mqtt/qmqtt_timerinterface.h
)

set(PRIVATE_HEADERS
 src/mqtt/qmqtt_client_p.h
 src/mqtt/qmqtt_message_p.h
 src/mqtt/qmqtt_network_p.h
 src/mqtt/qmqtt_socket_p.h
 src/mqtt/qmqtt_timer_p.h
)

set(SOURCES
 src/mqtt/qmqtt_client_p.cpp
 src/mqtt/qmqtt_client.cpp
 src/mqtt/qmqtt_frame.cpp
 src/mqtt/qmqtt_message.cpp
 src/mqtt/qmqtt_network.cpp
 src/mqtt/qmqtt_routesubscription.cpp
 src/mqtt/qmqtt_router.cpp
 src/mqtt/qmqtt_socket.cpp
 src/mqtt/qmqtt_timer.cpp
)

if(${PROJECT_NAME}_WEBSOCKETS)
 list(APPEND PRIVATE_HEADERS
  src/mqtt/qmqtt_websocket_p.h
  src/mqtt/qmqtt_websocketiodevice_p.h
 )
list(APPEND SOURCES
 src/mqtt/qmqtt_websocket.cpp
 src/mqtt/qmqtt_websocketiodevice.cpp
)
endif()

if(${PROJECT_NAME}_SSL)
 list(APPEND PRIVATE_HEADERS
  src/mqtt/qmqtt_ssl_socket_p.h
 )
list(APPEND SOURCES
 src/mqtt/qmqtt_ssl_socket.cpp
)
endif()


add_library(${PROJECT_NAME} ${library_build_type} ${SOURCES} ${PUBLIC_HEADERS} ${PRIVATE_HEADERS})
target_link_libraries(${PROJECT_NAME} PUBLIC Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Network ${ws_libname})

target_include_directories(${PROJECT_NAME}
 PUBLIC
 $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/mqtt>
 $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(${PROJECT_NAME}
 PROPERTIES
 VERSION                   ${PROJECT_VERSION}
 SOVERSION                 ${PROJECT_VERSION_MAJOR}
 CXX_STANDARD              17
 CXX_STANDARD_REQUIRED     OFF
)

=== lib/simde/CMakeLists.txt ===
#
# Copyright (c) 2024 Alex Spataru <https://github.com/alex-spataru>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.20)

add_library(simde INTERFACE)
target_include_directories(simde INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

#
# ARM64 processor optimizations
#
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(arm|aarch64)")
 message(STATUS "Detected ARM architecture")

 include(CheckCXXCompilerFlag)
 check_cxx_compiler_flag("-mfpu=neon" COMPILER_SUPPORTS_NEON)
 check_cxx_compiler_flag("-march=armv8-a+simd" COMPILER_SUPPORTS_ARMV8_SIMD)

 if(COMPILER_SUPPORTS_ARMV8_SIMD)
  target_compile_options(simde INTERFACE -march=armv8-a+simd -DCPU_ARM64)
  message(STATUS "Using ARMv8 Advanced SIMD optimizations")
 elseif(COMPILER_SUPPORTS_NEON)
  target_compile_options(simde INTERFACE -mfpu=neon -DCPU_ARM64)
  message(STATUS "Using ARM NEON optimizations")
 else()
  message(WARNING "No SIMD support detected on ARM; falling back to portable mode")
  add_compile_definitions(SIMDE_NO_NATIVE)
 endif()

#
# Intel/AMD processor optimizations
#
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(x86|x86_64|AMD64)")
 message(STATUS "Detected x86 architecture")
 if(MSVC)
  target_compile_options(simde INTERFACE /arch:SSE2 /DCPU_X86_64)
  message(STATUS "Enabled SSE2 optimizations for MSVC")
 else()
  target_compile_options(simde INTERFACE -msse2 -DCPU_X86_64)
  message(STATUS "Enabled SSE2 optimizations for GCC & LLVM")
 endif()

#
# Emulate SIMD instructions on unknown processors
#
else()
 message(WARNING "Unknown architecture; enabling portable fallback")
 add_compile_definitions(SIMDE_NO_NATIVE)
 target_compile_options(simde INTERFACE -DSIMDE_NO_NATIVE)
endif()

=== lib/QCodeEditor/example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(QCodeEditorExample)

set(CMAKE_CXX_STANDARD 17)

set(CMAKE_AUTOMOC On)
set(CMAKE_AUTORCC ON)

find_package(Qt6Core    CONFIG REQUIRED)
find_package(Qt6Widgets CONFIG REQUIRED)
find_package(Qt6Gui     CONFIG REQUIRED)

add_executable(QCodeEditorExample
    resources/demo_resources.qrc
    src/main.cpp
    src/MainWindow.cpp
    include/MainWindow.hpp
)

target_include_directories(QCodeEditorExample PUBLIC
    include
)

target_link_libraries(QCodeEditorExample
    Qt6::Core
    Qt6::Widgets
    Qt6::Gui
    QCodeEditor
)

=== lib/qmqtt/tests/auto/cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(qmake_cmake_files)

enable_testing()

find_package(Qt5Core REQUIRED)
find_package(Qt5Network REQUIRED)

include("${_Qt5CTestMacros}")

test_module_includes(
  QMQTT qmqtt_message.h
)

=== PKGBUILD ===
# Maintainer: umarcor <unai.martinezcorral@ehu.eus>

_realname=serial-studio
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.0.6
pkgrel=1
pkgdesc="Multi-purpose serial data visualization & processing program (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url="https://serial-studio.github.io/"
msys2_repository_url="https://github.com/Serial-Studio/Serial-Studio"
license=('spdx:MIT')
groups=("${MINGW_PACKAGE_PREFIX}-eda")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-connectivity"
         "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
         "${MINGW_PACKAGE_PREFIX}-qt6-graphs"
         "${MINGW_PACKAGE_PREFIX}-qt6-serialport")
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-qt6-location"
  "${MINGW_PACKAGE_PREFIX}-qt6-positioning"
  "${MINGW_PACKAGE_PREFIX}-qt6-svg"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        001-fix-build-and-package.patch)
sha256sums=('3141605fae37869f4375349bbfa0242ae66b3914ead31ea11866ab3fac2f20e4'
            'c5dc4ca6f5539aea8a88a1788b36743f4a477479996028b342477f6eb4b57874')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  patch -p1 -i "${srcdir}"/001-fix-build-and-package.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
      -G"Ninja" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DPRODUCTION_OPTIMIZATION=ON \
      ${_extra_config[@]} \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

check() {
  ${srcdir}/build-${MSYSTEM}/release/Serial-Studio.exe --help
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.md \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md
}
